#include <iostream>
#include "circle8.h"
#include <cassert>

namespace {
  const float pi = 3.14159;
} // namespace


Circle::Circle( const Point& p, const float& r) : P(p), rad(r) 
{
  quadric = gluNewQuadric();
  assert( quadric);
  gluQuadricDrawStyle(quadric, (GLenum) GLU_FILL );
}

float Circle::radius() const
{ return rad; }

float Circle::area() const
{ return pi * rad * rad; }

float Circle::circumference() const
{ return 2 * pi * rad; }

Point Circle::center() const
{ return P; }

void Circle::draw() const
{
  glPushMatrix();
  glTranslatef( P.x(), P.y(), 0.0);
  gluDisk( quadric, 0.0, rad, 40, 1);
  glPopMatrix();
  glutSwapBuffers();
}
