#include <complex>
#include <LEDA/real.h>

template <>
complex<leda_real>
sqrt<leda_real>( const complex<leda_real>& c)
{
  leda_real a = c.real();
  leda_real b = c.imag();
  int sgn     = sign( b); 
  if ( sgn == 0) 
  {
    if ( a >= 0 ) 
      { return ( complex<leda_real>( sqrt(a), leda_real(0))); }
    else 
      { return ( complex<leda_real>( leda_real(0), sqrt(-a))); } 
  }
  else
  {
    leda_real A = sqrt( ( a + sqrt( a*a + b*b))/2 );
    leda_real B = sqrt( (-a + sqrt( a*a + b*b))/2 );
    return ( complex<leda_real>( A, sgn * B )); 
  }
}

