#include <iostream>
#include <climits>          // CHAR_BIT
#include <cassert>
#include <GL/glut.h>

using namespace std;

int
main()
{
                         // typical C(++) types
  GLboolean B = false;   // unsigned char

  GLbyte   b;            // signed char
  GLubyte ub;            // unsigned char
  
  GLshort  s;            // signed short
  GLint    i;            // signed int or long
  GLsizei  i2;           // signed int or long
  
  GLushort us;           // unsigend short
  GLuint   ui;           // unsigned int or long

  GLfloat  f;            // float
  GLclampf f2;           // float
  GLdouble d;            // double
  GLclampd d2;           // double

  GLenum   i3;           // unsigned int or unsigned long
  GLbitfield i4;         // unsigned int or unsigned long
  
  assert( sizeof(char) == 1 );
  assert( CHAR_BIT == 8 );

  assert( sizeof(GLboolean)*CHAR_BIT == 8 );
  assert( sizeof(GLbyte)*CHAR_BIT == 8 );
  assert( sizeof(GLubyte)*CHAR_BIT == 8 );
  assert( sizeof(GLshort)*CHAR_BIT == 16 );
  assert( sizeof(GLushort)*CHAR_BIT == 16 );
  assert( sizeof(GLint)*CHAR_BIT == 32 );
  assert( sizeof(GLint) == sizeof( GLsizei) );
  assert( sizeof(GLuint)*CHAR_BIT == 32 );
  assert( sizeof(GLfloat)*CHAR_BIT == 32 );
  assert( sizeof(GLfloat) == sizeof( GLclampf) );
  assert( sizeof(GLdouble)*CHAR_BIT == 64 );
  assert( sizeof(GLdouble) == sizeof( GLclampd) );
  assert( sizeof(GLenum)*CHAR_BIT == 32 );
  assert( sizeof(GLbitfield)*CHAR_BIT == 32 );
  
  return 0;
}
